<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Data Display</title>
  <style>
    body {
      font-family: Arial, sans-serif;
      margin: 0;
      padding: 0;
      background-color: #f4f4f4;
    }

    h1 {
      text-align: center;
    }

    label {
      margin-right: 10px;
    }

    input[type="date"] {
      margin-right: 20px;
    }

    button {
      margin-right: 10px;
      padding: 5px 10px;
      border: none;
      border-radius: 4px;
      background-color: #007bff;
      color: #fff;
      cursor: pointer;
    }

    button:hover {
      background-color: #0056b3;
    }

    table {
      width: 100%;
      border-collapse: collapse;
      margin-top: 20px;
    }

    th, td {
      border: 1px solid #ddd;
      padding: 8px;
      text-align: left;
      word-wrap: break-word;
      max-width : 350px;
    }

    th {
      background-color: #f2f2f2;
    }

    tr:nth-child(even) {
      background-color: #f2f2f2;
    }

    tr:hover {
      background-color: #ddd;
    }
  </style>
</head>
<body>
  <h1>Data Display</h1>
  <label for="fromDate">From:</label>
  <input type="date" id="fromDate">
  <label for="toDate">To:</label>
  <input type="date" id="toDate">
  <button onclick="filterData()">Filter</button>
  <button onclick="resetDates()">Reset</button>
  <table id="dataTable">
    <thead>
      <tr>
        <th>IMEI</th>
        <th>TYPE</th>
        <th>IP Address</th>
        <th>Data</th>
        <th>Date Time</th>
        <th>Server Hit Time</th>
      </tr>
    </thead>
    <tbody id="dataBody">
      <!-- Table body will be populated dynamically -->
    </tbody>
  </table>

  <script>
    let originalData = []; // To store the original data fetched from the server

    async function fetchData(startDate = '', endDate = '') {
      try {
        let url = '/api/data';
        if (startDate && endDate) {
          url += `?startDate=${startDate}&endDate=${endDate}`;
        }
        const response = await fetch(url);
        const data = await response.json();
        return data;
      } catch (error) {
        console.error('Error fetching data:', error);
        return [];
      }
    }

    async function displayData(data) {
      const dataTable = document.getElementById('dataTable');
      const dataBody = document.getElementById('dataBody');
      dataBody.innerHTML = ''; // Clear previous data

      data.forEach(entry => {
        const row = document.createElement('tr');
        row.innerHTML = `
          <td>${entry.imei}</td>
          <td>${entry.type}</td>
          <td>${entry.ipAddress}</td>
          <td>${entry.data}</td>
          <td>${new Date(entry.dateTime).toLocaleString()}</td>
          <td>${new Date(entry.serverhittime).toLocaleString()}</td>
        `;
        dataBody.appendChild(row);
      });
    }

    async function filterData() {
      const fromDate = document.getElementById('fromDate').value;
      const toDate = document.getElementById('toDate').value;
      const filteredData = await fetchData(fromDate, toDate);
      displayData(filteredData);
    }

    async function resetDates() {
      document.getElementById('fromDate').value = '';
      document.getElementById('toDate').value = '';
      const allData = await fetchData();
      displayData(allData);
    }

    async function initialize() {
      originalData = await fetchData();
      displayData(originalData);
    }

    window.onload = function () {
      initialize();
    };
  </script>
</body>
</html>
